#TEMPLATE(wPDFControl,'Use wPDFControl in Clarion'), FAMILY('ABC'), FAMILY('CW20'), FAMILY('CLARION')
#!====================================================================================================================
#! Interface wPDFControl to the IceTips Previewer
#! to generate PDF documents
#!====================================================================================================================
#EXTENSION(wPDFGlobal,'wPDFControl Global Declarations'),DESCRIPTION('wPDFControl Global Declarations'),APPLICATION
#DISPLAY ('Global wPDFControl extension for the application')
#PROMPT('wPDF Demo Version', CHECK), %wPDFDemo,DEFAULT(%TRUE),AT(10)
#ENABLE(NOT %wPDFDemo)
#PROMPT  ('License Name:',@S64),%LicenseName
#PROMPT  ('License Code:',@S64),%LicenseCode
#PROMPT  ('License Number:',@S64),%LicenseNumber
#ENDENABLE
#DISPLAY
#DISPLAY ('When "Demo Version" is checked app uses ')
#DISPLAY ('wPDFControlDemo.dll and generated PDF files will have ')
#DISPLAY ('watermarks.')
#DISPLAY ('With this option unchecked wPDFControl02.dll will be used.')
#DISPLAY ('You will need to provide registartion info.')
#DISPLAY ('For information about registering wPDFControl contact KlariSoft.')
#DISPLAY
#PROMPT('Support E-Mail:',@S200),%CompanyMail,DEFAULT('support@klarisoft.com'),PROP(PROP:ReadOnly,1),PROP(PROP:Skip,1)
#PROMPT('Official Site:',@S200),%CompanySite,DEFAULT('http://www.klarisoft.com'),PROP(PROP:ReadOnly,1),PROP(PROP:Skip,1)
#DISPLAY()
#!====================================================================================================================
#AT(%AfterGlobalIncludes)
    #IF( %ApplicationLocalLibrary )
  #IF(%wPDFDemo)
   INCLUDE('cwPDFControllibdemo.inc'),ONCE
  #ELSE
   INCLUDE('cwPDFControllib.inc'),ONCE
  #END
    #ELSE
   INCLUDE('cwPDFControl.inc'),ONCE
    #END
#ENDAT
#!====================================================================================================================
#AT(%CustomGlobalDeclarations)
  #IF(%wPDFDemo)
    #IF( %ApplicationLocalLibrary )
      #PROJECT('wpdfcontrolwrapperdemol.lib')
    #ELSE
      #PROJECT('wpdfcontrolwrapperdemo.lib')
    #ENDIF
  #ELSE
    #IF( %ApplicationLocalLibrary )
      #PROJECT('wpdfcontrolwrapperl.lib')
    #ELSE
      #PROJECT('wpdfcontrolwrapper.lib')
    #ENDIF
  #ENDIF
#ENDAT

#!====================================================================================================================
#AT(%BeforeGenerateApplication)
    #IF(NOT %ApplicationLocalLibrary )
      #pdefine('_wPDFControlDllMode_',1)
      #pdefine('_wPDFControlLinkMode_',0)
    #ENDIF
#ENDAT
#!====================================================================================================================

#CONTROL(ITPwPDFExport,'Export Report to PDF'),WINDOW,REQ(wPDFGlobal)
#!
#DISPLAY ('This Control Template Adds PDF Export Button')
#DISPLAY ('')
#BOXED
#PROMPT ('PDF File:', @s128 ),%PDFFileName,DEFAULT('!PDFname') 
#DISPLAY('Leave blank to display "Save As" dialog, use file name or' )
#DISPLAY('variable (prefixed with !).')
#ENDBOXED
#DISPLAY('')
#!

  CONTROLS
    BUTTON,AT(,,14,12),USE(?wPDFExp),ICON('ITPdfTools.ico')
  END

#!====================================================================================================================
#ATSTART
  #DECLARE(%wPDFButton)
  #FOR(%Control),WHERE(%ControlInstance = %ActiveTemplateInstance)
    #SET(%wPDFButton,%Control)
  #ENDFOR
#ENDAT

#!====================================================================================================================
#AT(%DataSection)
KS_wPDFControl          wPDFControl
ITP:ImageWidthThous     LONG
ITP:ImageHeightThous    LONG
#ENDAT

#!====================================================================================================================
#AT(%ProcedureRoutines)
GetPageWidthHeight ROUTINE
    Get(ITP:PageQueue,1)                           
    ITPreviewWindow {Prop:Thous}  = True
    ITP:TempImage                 = Create(0, CREATE:Image)
    ITP:TempImage {PROP:Text}     = ITP:PageQueue.ITP:PQ:WmfFile
    ITP:ImageWidthThous           = ITP:TempImage{PROP:Width}
    ITP:ImageHeightThous          = ITP:TempImage{PROP:Height}
    Destroy(ITP:TempImage)
    ITPreviewWindow {Prop:Thous}  = False
#ENDAT

#!====================================================================================================================
#AT(%ControlEventHandling,%wPDFButton,'Accepted')
#DECLARE( %TempPDFName )

  Do GetPageWidthHeight
  #IF(NOT %wPDFDemo)
  KS_wPDFControl.SetLicenseKey(%LicenseNumber,'%LicenseName','%LicenseCode')
  #ENDIF
  PdfEnv# = KS_wPDFControl.Initialize()
  #IF( SUB(%PDFFileName,1,1) = '!' )
  #SET( %TempPDFName, SUB( %PDFFileName, 2, LEN( %PDFFileName ) ) )
  R# = KS_wPDFControl.BeginDoc(Clip(%TempPDFName))
  #ELSE
  R# = KS_wPDFControl.BeginDoc('%PDFFileName')
  #ENDIF
  loop I# = 1 to Records(ITP:PageQueue)
    Get(ITP:PageQueue,I#)
    If ITP:PQ:PrintPage
      !KS_wPDFControl.StartPage()
      KS_wPDFControl.StartPageEx(ITP:ImageWidthThous*72/1000, ITP:ImageHeightThous*72/1000)
      KS_wPDFControl.DrawWmf(ITP:PQ:WmfFile, 0, 0, ITP:ImageWidthThous*72/1000, ITP:ImageHeightThous*72/1000)
      KS_wPDFControl.EndPage()
    End
  End
  KS_wPDFControl.EndDoc()
  KS_wPDFControl.Finalize()
  #EMBED(%ButtonAcceptedEmbed,'Control Events'),%wPDFButton,'After Generating PDF File'
#ENDAT

#!====================================================================================================================
#EXTENSION (SaveCWReportToPDF,'Save Report to PDF'),SHOW,REQ(wPDFGlobal)
#!
#SHEET
#TAB('General')
#DISPLAY ('This Template Saves Report to PDF')
#DISPLAY ('')
#BOXED
#PROMPT ('PDF File:', @s128 ),%PDFFileName,DEFAULT('!PDFname')
#DISPLAY('Leave blank to display "Save As" dialog, use file name or' )
#DISPLAY('variable (prefixed with !).')
#ENDBOXED
#!PROMPT('Print/Preview Report as Usual',CHECK),%PrintAsAlways,DEFAULT(%TRUE),AT(10)
#PROMPT('Mode to Run Report',EXPR),%LocMode,DEFAULT('KS:ReportMode')
#DISPLAY('If variable is FALSE (default) report will be saved to PDF' )
#DISPLAY('If variable is TRUE reprt will be also printed/previewed' )
#DISPLAY('')
#ENDTAB
#TAB('PDF Options')
#PROMPT('Compression',OPTION),%PDFCompression,DEFAULT('None')
#PROMPT('None',RADIO)
#PROMPT('Deflate',RADIO)
#PROMPT('Runlength',RADIO)
#PROMPT('Fast Deflate',RADIO)
#PROMPT('JPEG Compression',OPTION),%JPEGCompression,DEFAULT('Off')
#PROMPT('Off',RADIO)
#PROMPT('10%',RADIO)
#PROMPT('25%',RADIO)
#PROMPT('50%',RADIO)
#PROMPT('75%',RADIO)
#PROMPT('100%',RADIO)
#ENDTAB
#TAB('PDF Security')
#PROMPT('Enable Security', CHECK), %PDFSecurity,DEFAULT(%FALSE)
#ENABLE(%PDFSecurity)
#PROMPT  ('Enable Printing',CHECK),%EnablePrinting
#PROMPT  ('Enable Changing',CHECK),%EnableChanging
#PROMPT  ('Enable Copying',CHECK),%EnableCopying
#PROMPT  ('Enable Forms',CHECK),%EnableForms
#PROMPT  ('User Password:',@S64),%UserPassword
#PROMPT  ('Owner Password:',@S64),%OwnerPassword
#DISPLAY('Password or variable (prefixed with !).')
#ENDENABLE
#ENDTAB
#ENDSHEET
#!
#!vivid support variable
#LOCALDATA
PDFname             STRING('report.pdf {246}')
KS:ReportMode       BYTE(FALSE)
#ENDLOCALDATA
#!
#ATSTART
#INSERT(%KSCWDetect)
#ENDAT

#!====================================================================================================================
#AT(%DataSection),WHERE(%KSCWABCTemplate)
#INSERT(%KSLocalData)
#ENDAT

#AT(%DeclarationSection),WHERE(NOT %KSCWABCTemplate)
#INSERT(%KSLocalData)
#ENDAT

#!====================================================================================================================
#AT( %WindowManagerMethodCodeSection,'AskPreview','()'),PRIORITY(2000),WHERE(%KSCWABCTemplate)
#INSERT(%GroupPDFOptions)
  !Save report to PDF code.
  If Not SELF.Report &= NULL
    If Not SELF.Preview &= NULL And SELF.Response = RequestCompleted
      EndPage(SELF.Report)
      Get(SELF.PreviewQueue,1)
      0{Prop:Thous}  = True
      KS:TempImage                 = Create(0, CREATE:Image)
      KS:TempImage {PROP:Text}     = SELF.PreviewQueue.FileName
      KS:ImageWidthThous           = KS:TempImage{PROP:Width}
      KS:ImageHeightThous          = KS:TempImage{PROP:Height}
      Destroy(KS:TempImage)
      0{Prop:Thous}  = False
      #INSERT(%GroupPDFInitialize)
      loop I# = 1 to Records(SELF.PreviewQueue)
        Get(SELF.PreviewQueue,I#)
        KS_wPDFControl.StartPageEx(KS:ImageWidthThous*72/1000, KS:ImageHeightThous*72/1000)
        KS_wPDFControl.DrawWmf(SELF.PreviewQueue.FileName, 0, 0, KS:ImageWidthThous*72/1000, KS:ImageHeightThous*72/1000)
        KS_wPDFControl.EndPage()
      End
      KS_wPDFControl.EndDoc()
      KS_wPDFControl.Finalize()
  #EMBED(%EndOfPDFGenerating,'AskPreview'),'After Generating PDF File'
      IF NOT %LocMode
        SELF.Report {PROP:FlushPreview} = False
        FREE(SELF.PreviewQueue)
        Return
      END
    End
  End
#ENDAT

#!====================================================================================================================
#AT( %BeforePrintPreview),PRIORITY(6000),WHERE(NOT %KSCWABCTemplate)
#INSERT(%GroupPDFOptions)
  !Save report to PDF code.
  If LocalResponse = RequestCompleted
      EndPage(%Report)
      Get(PrintPreviewQueue,1)
      0{Prop:Thous}  = True
      KS:TempImage                 = Create(0, CREATE:Image)
      KS:TempImage {PROP:Text}     = PrintPreviewQueue.PrintPreviewImage
      KS:ImageWidthThous           = KS:TempImage{PROP:Width}
      KS:ImageHeightThous          = KS:TempImage{PROP:Height}
      Destroy(KS:TempImage)
      0{Prop:Thous}  = False
      #INSERT(%GroupPDFInitialize)
      loop I# = 1 to Records(PrintPreviewQueue)
        Get(PrintPreviewQueue,I#)
        KS_wPDFControl.StartPageEx(KS:ImageWidthThous*72/1000, KS:ImageHeightThous*72/1000)
        KS_wPDFControl.DrawWmf(PrintPreviewQueue.PrintPreviewImage, 0, 0, KS:ImageWidthThous*72/1000, KS:ImageHeightThous*72/1000)
        KS_wPDFControl.EndPage()
      End
      KS_wPDFControl.EndDoc()
      KS_wPDFControl.Finalize()
  #EMBED(%EndOfPDFGenerating,'PDF Created'),'After Generating PDF File'
      IF NOT %LocMode
        %Report{PROP:FlushPreview} = FALSE
        Close(%Report)
        FREE(PrintPreviewQueue)
        DO ProcedureReturn
      END
  End
#ENDAT

#!====================================================================================================================
#!
#! 
#GROUP(%KSCWDetect)
#DECLARE (%KSCWVERSION)
#DECLARE (%KSCWABCTemplate)
#DECLARE (%KSCWTEMPLATEVERSION)
#DECLARE (%KSCWTEMPLATESET)
#DECLARE (%KSABCVersion)
#SET (%KSCWVERSION, SUB(%CWVersion, 1, 1))
#IF (INSTRING('V2', UPPER(%CWTemplateVersion), 1, 1))
  #SET (%KSCWTEMPLATEVERSION, 2)
  #SET (%KSCWTEMPLATESET, 'CFW')
#ELSIF (INSTRING('V4', UPPER(%CWTemplateVersion), 1, 1))
  #SET (%KSCWTEMPLATEVERSION, 4)
  #SET (%KSCWTEMPLATESET, 'ABC')
#ELSIF (INSTRING('V5', UPPER(%CWTemplateVersion), 1, 1))
#IF(VAREXISTS(%ABCVersion))       #! In Clarion 5.5f Legacy %CWTemplateVersion was changed from 'v2.003' to 'v5.5'
  #SET (%KSCWTEMPLATEVERSION, 5) #!
  #SET (%KSCWTEMPLATESET, 'ABC') #!
#ELSE                             #!
  #SET (%KSCWTEMPLATEVERSION, 5) #!
  #SET (%KSCWTEMPLATESET, 'CFW') #!
#ENDIF
#ELSIF (INSTRING('V6', UPPER(%CWTemplateVersion), 1, 1))
#IF(VAREXISTS(%ABCVersion))       #! In Clarion 5.5f Legacy %CWTemplateVersion was changed from 'v2.003' to 'v5.5'
  #SET (%KSCWTEMPLATEVERSION, 6) #!
  #SET (%KSCWTEMPLATESET, 'ABC') #!
#ELSE                             #!
  #SET (%KSCWTEMPLATEVERSION, 6) #!
  #SET (%KSCWTEMPLATESET, 'CFW') #!
#ENDIF
#ENDIF
#IF (%KSCWTEMPLATESET = 'ABC')
  #SET(%KSCWABCTemplate,1)
#ELSE
  #SET(%KSCWABCTemplate,0)
#ENDIF
#!
#!

#!====================================================================================================================
#!
#! 
#GROUP(%KSLocalData)
KS_wPDFControl          wPDFControl
KS:ImageWidthThous      LONG
KS:ImageHeightThous     LONG
KS:TempImage            SHORT

#!====================================================================================================================
#!
#! 
#GROUP(%GroupPDFOptions)
#DECLARE( %TempPDFName )
#DECLARE( %TempUserPassword )
#DECLARE( %TempOwnerPassword )

#DECLARE( %PDFCompressionVal )
#IF (%PDFCompression = 'None')
 #SET( %PDFCompressionVal, '0' )
#ELSIF (%PDFCompression = 'Deflate')
 #SET( %PDFCompressionVal, '1' )
#ELSIF (%PDFCompression = 'Runlength')
 #SET( %PDFCompressionVal, '2' )
#ELSIF (%PDFCompression = 'Fast Deflate')
 #SET( %PDFCompressionVal, '3' )
#ENDIF
#DECLARE( %JPEGCompressionVal )
#IF (%JPEGCompression = 'Off')
 #SET( %JPEGCompressionVal, '0' )
#ELSIF (%JPEGCompression = '10%')
 #SET( %JPEGCompressionVal, '1' )
#ELSIF (%JPEGCompression = '25%')
 #SET( %JPEGCompressionVal, '2' )
#ELSIF (%JPEGCompression = '50%')
 #SET( %JPEGCompressionVal, '3' )
#ELSIF (%JPEGCompression = '75%')
 #SET( %JPEGCompressionVal, '4' )
#ELSIF (%JPEGCompression = '100%')
 #SET( %JPEGCompressionVal, '5' )
#ENDIF


#!====================================================================================================================
#!
#! 
#GROUP(%GroupPDFInitialize)
#IF(NOT %wPDFDemo)
KS_wPDFControl.SetLicenseKey(%LicenseNumber,'%LicenseName','%LicenseCode')
#ENDIF
KS_wPDFControl.Compression = %PDFCompressionVal
KS_wPDFControl.JPEGCompress = %JPEGCompressionVal
#IF (%PDFSecurity)
KS_wPDFControl.Permission = 1
#IF (%EnablePrinting)
KS_wPDFControl.Permission += 2
#ENDIF
#IF (%EnableChanging)
KS_wPDFControl.Permission += 4
#ENDIF
#IF (%EnableCopying)
KS_wPDFControl.Permission += 8
#ENDIF
#IF (%EnableForms)
KS_wPDFControl.Permission += 16
#ENDIF
#IF( SUB(%UserPassword,1,1) = '!' )
#SET( %TempUserPassword, SUB( %UserPassword, 2, LEN( %UserPassword ) ) )
KS_wPDFControl.UserPassword = %TempUserPassword
#ELSE
KS_wPDFControl.UserPassword = '%UserPassword'
#ENDIF
#IF( SUB(%OwnerPassword,1,1) = '!' )
#SET( %TempOwnerPassword, SUB( %OwnerPassword, 2, LEN( %OwnerPassword ) ) )
KS_wPDFControl.OwnerPassword = %TempOwnerPassword
#ELSE
KS_wPDFControl.OwnerPassword = '%OwnerPassword'
#ENDIF
#ENDIF
#EMBED(%BeforePDFInitialize,'Before PDF Initialize')
PdfEnv# = KS_wPDFControl.InitializeEx()
#IF( SUB(%PDFFileName,1,1) = '!' )
#SET( %TempPDFName, SUB( %PDFFileName, 2, LEN( %PDFFileName ) ) )
R# = KS_wPDFControl.BeginDoc(Clip(%TempPDFName))
#ELSE
R# = KS_wPDFControl.BeginDoc('%PDFFileName')
#ENDIF
